﻿namespace Hotline.Share.Dtos.FlowEngine;

/// <summary>
/// 工作流流转基础信息
/// </summary>
public class BasicWorkflowDto : EndWorkflowDto
{
    /// <summary>
    /// 下一节点code(defineStep.code)
    /// </summary>
    public string NextStepCode { get; set; } = string.Empty;

    /// <summary>
    /// 根据办理者类型不同，此字段为不同内容
    /// <example>
    /// 部门等级/分类为：depCodes, 角色为：userIds
    /// </example>
    /// </summary>
    public List<IdName> NextHandlers { get; set; } = new();

    /// <summary>
    /// 是否短信通知
    /// </summary>
    public bool AcceptSms { get; set; }

    /// <summary>
    /// 下一节点主办
    /// </summary>
    public string? NextMainHandler { get; set; }
}