﻿using Hotline.Share.Dtos.FlowEngine;
using Hotline.Share.Enums.FlowEngine;
using XF.Domain.Entities;

namespace Hotline.FlowEngine.Definitions;

/// <summary>
/// 模板定义节点
/// </summary>
public class StepDefine : StepBasic
{
    public List<NextStepDefine> NextSteps { get; set; }

    /// <summary>
    /// 判断上级节点是否能发起会签
    /// <remarks>下级节点配置决定当前办理节点能否发起会签</remarks>
    /// </summary>
    /// <param name="handlerCount">下一节点办理人数量</param>
    /// <returns></returns>
    public bool CouldPrevStartCountersign(int handlerCount)
    {
        if (StepType is EStepType.End or EStepType.CountersignEnd) return false;

        //需求：按角色指派默认不发起会签
        if (HandlerType is EHandlerType.Role) return false;

        return CountersignMode == ECountersignMode.Support && handlerCount > 1;
    }
}