﻿using Hotline.Share.Enums.Order;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.Orders;

/// <summary>
/// 工单扩展信息（12315-投诉）
/// </summary>
public class OrderComplain : OrderExtensionEntity
{
    #region 投诉详情

    /// <summary>
    /// 投诉问题类别
    /// </summary>
    public string ComplainClassifyCode { get; set; }

    public string ComplainClassify { get; set; }

    /// <summary>
    /// 争议发生时间
    /// </summary>
    public DateTime OccurrenceTime { get; set; }

    /// <summary>
    /// 投诉目标，销售方式为“网购”时展示该字段且必填
    /// </summary>
    [SugarColumn(IsNullable = true)]
    public string? ComplainTargetCode { get; set; }

    [SugarColumn(IsNullable = true)]
    public string? ComplainTarget { get; set; }

    /// <summary>
    /// 经营地址，销售方式为“现场”时必填
    /// </summary>
    //todo 地址信息不够完善
    [SugarColumn(IsNullable = true)]
    public string? BussinessArea { get; set; }

    [SugarColumn(IsNullable = true)]
    public string? BussinessAddress { get; set; }

    /// <summary>
    /// 诉求内容，多选
    /// </summary>
    [SugarColumn(ColumnDataType = "json", IsJson = true)]
    public List<EComplainType> ComplainTypes { get; set; } = new();

    #endregion
}