﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Hotline.FlowEngine.Definitions;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.Settings;

/// <summary>
/// 工作流业务模块
/// </summary>
public class WorkflowModule
{
    /// <summary>
    /// code: name
    /// </summary>
    public static Dictionary<string, string> Modules { get; } =
        new Dictionary<string, string>
        {
            { WorkflowModuleConsts.OrderManage, "工单办理" },
            { WorkflowModuleConsts.KnowledgeAdd, "新增知识审批" },
            { WorkflowModuleConsts.KnowledgeUpdate, "知识更新" },
            { WorkflowModuleConsts.KnowledgeDelete, "知识删除" },
            { WorkflowModuleConsts.TelRestApply,"分机小休申请" },
        };
}

public class WorkflowModuleConsts
{
    /// <summary>
    /// 工单办理
    /// </summary>
    public const string OrderManage = "Order";

    /// <summary>
    /// 新增知识审批
    /// </summary>
    public const string KnowledgeAdd = "KnowledgeAdd";

    /// <summary>
    /// 知识更新
    /// </summary>
    public const string KnowledgeUpdate = "KnowledgeUpdate";

    /// <summary>
    /// 知识删除
    /// </summary>
    public const string KnowledgeDelete = "KnowledgeDelete";

    /// <summary>
    /// 分机小休申请
    /// </summary>
    public const string TelRestApply = "TelRestApply";
}